<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<meta name="keywords" content="NewAPI/exnew events.c,NewAPI/Events" />
		<link rel="shortcut icon" href="/favicon.ico" />
		<link rel="search" type="application/opensearchdescription+xml" href="/opensearch_desc.php" title="Allegro Wiki (English)" />
		<title>NewAPI/exnew events.c - Allegro Wiki</title>
		<style type="text/css" media="screen, projection">/*<![CDATA[*/
			@import "/skins/common/shared.css?97";
			@import "/skins/monobook/main.css?97";
		/*]]>*/</style>
		<link rel="stylesheet" type="text/css" media="print" href="/skins/common/commonPrint.css?97" />
		<!--[if lt IE 5.5000]><style type="text/css">@import "/skins/monobook/IE50Fixes.css?97";</style><![endif]-->
		<!--[if IE 5.5000]><style type="text/css">@import "/skins/monobook/IE55Fixes.css?97";</style><![endif]-->
		<!--[if IE 6]><style type="text/css">@import "/skins/monobook/IE60Fixes.css?97";</style><![endif]-->
		<!--[if IE 7]><style type="text/css">@import "/skins/monobook/IE70Fixes.css?97";</style><![endif]-->
		<!--[if lt IE 7]><script type="text/javascript" src="/skins/common/IEFixes.js?97"></script>
		<meta http-equiv="imagetoolbar" content="no" /><![endif]-->
		
		<script type= "text/javascript">/*<![CDATA[*/
var skin = "monobook";
var stylepath = "/skins";
var wgArticlePath = "/index.php?title=$1";
var wgScriptPath = "";
var wgScript = "/index.php";
var wgServer = "http://wiki.allegro.cc";
var wgCanonicalNamespace = "";
var wgCanonicalSpecialPageName = false;
var wgNamespaceNumber = 0;
var wgPageName = "NewAPI/exnew_events.c";
var wgTitle = "NewAPI/exnew events.c";
var wgAction = "view";
var wgRestrictionEdit = [];
var wgRestrictionMove = [];
var wgArticleId = "590";
var wgIsArticle = true;
var wgUserName = null;
var wgUserGroups = null;
var wgUserLanguage = "en";
var wgContentLanguage = "en";
var wgBreakFrames = false;
var wgCurRevisionId = "4602";
/*]]>*/</script>
                
		<script type="text/javascript" src="/skins/common/wikibits.js?97"><!-- wikibits js --></script>
		<script type="text/javascript" src="/index.php?title=-&amp;action=raw&amp;gen=js&amp;useskin=monobook"><!-- site js --></script>
		<style type="text/css">/*<![CDATA[*/
@import "/index.php?title=MediaWiki:Common.css&usemsgcache=yes&action=raw&ctype=text/css&smaxage=18000";
@import "/index.php?title=MediaWiki:Monobook.css&usemsgcache=yes&action=raw&ctype=text/css&smaxage=18000";
@import "/index.php?title=-&action=raw&gen=css&maxage=18000";
/*]]>*/</style>
		<!-- Head Scripts -->
		<script type="text/javascript" src="/skins/common/ajax.js?97"></script>
	</head>
<body  class="mediawiki ns-0 ltr page-NewAPI_exnew_events_c">
	<div id="globalWrapper">
		<div id="column-content">
	<div id="content">
		<a name="top" id="top"></a>
				<h1 class="firstHeading">NewAPI/exnew events.c</h1>
		<div id="bodyContent">
			<h3 id="siteSub">From Allegro Wiki</h3>
			<div id="contentSub"><span class="subpages">&lt; <a href="/index.php?title=NewAPI" title="NewAPI">NewAPI</a></span></div>
									<div id="jump-to-nav">Jump to: <a href="#column-one">navigation</a>, <a href="#searchInput">search</a></div>			<!-- start content -->
			<p><b>exnew_events.c, version 4.9.4</b>
</p><p>Part of the <a href="/index.php?title=NewAPI/Events" title="NewAPI/Events">NewAPI/Events</a> module.
</p>
<div style="font-weight: bold;"><pre>
<font color="green" style="font-style=italic;">/*
*    Example program for the Allegro library, by Peter Wang.
*    Updated with to conform to new API by Ryan Dickie
*
*    This is a very simple program showing how to use the new event
*    interface introduced in Allegro 4.9.0.
*
*    Everything is still subject to change, though the event interface is
*    unlikely to change very much now.  The new display API is less stable.
*/</font>

<font color="">#include &lt;allegro5/allegro5.h&gt;</font>
<font color="">#include &lt;allegro5/a5_font.h&gt;</font>


<font color="">#define WIDTH        640</font>
<font color="">#define HEIGHT       480</font>
<font color="">#define MAX_MSG_LEN  80</font>
<font color="">#define SIZE_LOG     40</font>


<font color="green" style="font-style=italic;">/* globals */</font>
ALLEGRO_EVENT_QUEUE *event_queue;
ALLEGRO_DISPLAY     *display;
ALLEGRO_TIMER       *timer_a;
ALLEGRO_TIMER       *timer_b;
ALLEGRO_TIMER       *timer_c;
ALLEGRO_FONT         *myfont;
ALLEGRO_COLOR        black;
ALLEGRO_COLOR        grey;
ALLEGRO_COLOR        white;

<font color="green" style="font-style=italic;">/* circular array of log messages */</font>
<font color="blue">static</font> <font color="blue">char</font> msg_log[SIZE_LOG][MAX_MSG_LEN];
<font color="blue">static</font> <font color="blue">int</font> msg_head = 0;
<font color="blue">static</font> <font color="blue">int</font> msg_tail = 0;



<font color="green" style="font-style=italic;">/* Add a message to the log. */</font>
<font color="blue">static</font> <font color="blue">void</font> log_message(<font color="blue">char</font> <font color="blue">const</font> *message)
{
        ustrzcpy(msg_log[msg_head], MAX_MSG_LEN, message);
        msg_head = (msg_head + 1)&nbsp;% SIZE_LOG;
        <font color="blue">if</font> (msg_head == msg_tail) {
                msg_tail = (msg_tail + 1)&nbsp;% SIZE_LOG;
        }
}



<font color="green" style="font-style=italic;">/* Draw the message log to the screen. */</font>
<font color="blue">static</font> <font color="blue">int</font> num_messages(<font color="blue">void</font>)
{
        <font color="blue">if</font> (msg_head &lt; msg_tail) {
                <font color="blue">return</font> (SIZE_LOG - msg_tail) + msg_head;
        }
        <font color="blue">else</font> {
                <font color="blue">return</font> msg_head - msg_tail;
        }
}

<font color="blue">static</font> <font color="blue">void</font> draw_message_log(<font color="blue">void</font>)
{
        <font color="blue">const</font> <font color="blue">int</font> th = al_font_text_height(myfont);
        <font color="blue">int</font> y;
        <font color="blue">int</font> i;

        al_set_blender(ALLEGRO_ALPHA, ALLEGRO_INVERSE_ALPHA, black);

        <font color="green" style="font-style=italic;">/* Scroll down the log if necessary. */</font>
        <font color="blue">while</font> (num_messages() &gt;= (HEIGHT/th)) {
                msg_tail = (msg_tail + 1)&nbsp;% SIZE_LOG;
        }

        y = 0;
        i = msg_tail;
        <font color="blue">while</font> (1) {
                al_font_textout(myfont, msg_log[i], 5, y);
                y += th;

                i = (i + 1)&nbsp;% SIZE_LOG;
                <font color="blue">if</font> (i == msg_head) {
                        <font color="blue">break</font>;
                }
        }

        al_set_blender(ALLEGRO_ONE, ALLEGRO_ZERO, white);
}



<font color="green" style="font-style=italic;">/* Print some text. */</font>
<font color="blue">static</font> <font color="blue">void</font> print(<font color="blue">int</font> x, <font color="blue">int</font> y, <font color="blue">char</font> <font color="blue">const</font> *message)
{
        al_set_blender(ALLEGRO_ALPHA, ALLEGRO_INVERSE_ALPHA, black);
        al_font_textout(myfont, message, x, y);
        al_set_blender(ALLEGRO_ONE, ALLEGRO_ZERO, white);
}



<font color="green" style="font-style=italic;">/* Display an error message and quit. */</font>
<font color="blue">void</font> fatal_error(<font color="blue">const</font> <font color="blue">char</font> *msg)
{
        <font color="blue">char</font> buf[MAX_MSG_LEN];

        <font color="green" style="font-style=italic;">//set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);</font>
        uszprintf(buf, <font color="blue">sizeof</font>(buf), "<font color="blue">fatal_error:&nbsp;%s\n</font>", msg);
        <font color="green" style="font-style=italic;">//allegro_message(buf);</font>
        <font color="gray">exit</font>(EXIT_FAILURE);
}



<font color="green" style="font-style=italic;">/*
* The following functions deal with drawing some representation of the
* keyboard, mouse, joystick and timer events on screen.
* The interesting stuff doesn't really begin until main_loop(), below.
*/</font>
<font color="blue">void</font> log_key_down(<font color="blue">int</font> keycode, <font color="blue">int</font> unichar, <font color="blue">int</font> modifiers)
{
        <font color="blue">char</font> buf[MAX_MSG_LEN];
        <font color="blue">char</font> unistr[10] = "<font color="blue"></font>";

        usetat(unistr, 0, unichar);
        uszprintf(buf, <font color="blue">sizeof</font>(buf),
        "<font color="blue">Down:&nbsp;%3d &lt;%1s&gt;&nbsp;%04x [%08x]</font>", keycode, unistr, unichar, modifiers);
        log_message(buf);
}



<font color="blue">void</font> log_key_repeat(<font color="blue">int</font> keycode, <font color="blue">int</font> unichar, <font color="blue">int</font> modifiers)
{
        <font color="blue">char</font> buf[MAX_MSG_LEN];
        <font color="blue">char</font> unistr[10] = "<font color="blue"></font>";

        usetat(unistr, 0, unichar);
        uszprintf(buf, <font color="blue">sizeof</font>(buf),
        "<font color="blue">Rept:&nbsp;%3d &lt;%1s&gt;&nbsp;%04x [%08x]</font>", keycode, unistr, unichar, modifiers);
        log_message(buf);
}



<font color="blue">void</font> log_key_up(<font color="blue">int</font> keycode, <font color="blue">int</font> unichar, <font color="blue">int</font> modifiers)
{
        <font color="blue">char</font> buf[MAX_MSG_LEN];
        <font color="blue">char</font> unistr[10] = "<font color="blue"></font>";

        usetat(unistr, 0, unichar);
        uszprintf(buf, <font color="blue">sizeof</font>(buf),
        "<font color="blue">Up:  &nbsp;%3d &lt;%1s&gt;&nbsp;%04x [%08x]</font>", keycode, unistr, unichar, modifiers);
        log_message(buf);
}



<font color="blue">void</font> log_general(<font color="blue">char</font> <font color="blue">const</font> *format, ...)
{
        <font color="blue">char</font> buf[MAX_MSG_LEN];
        <font color="gray">va_list</font> args;
        <font color="gray">va_start</font>(args, format);

        uvszprintf(buf, <font color="blue">sizeof</font>(buf), format, args);
        <font color="gray">va_end</font>(args);

        log_message(buf);
}



<font color="blue">void</font> draw_timer_tick(ALLEGRO_TIMER *timer, <font color="blue">long</font> count)
{
        <font color="blue">char</font> buf[MAX_MSG_LEN];
        <font color="blue">int</font> y;

        <font color="blue">if</font> (timer == timer_a) {
                y = 50;
        } <font color="blue">else</font> <font color="blue">if</font> (timer == timer_b) {
                y = 70;
        } <font color="blue">else</font> <font color="blue">if</font> (timer == timer_c) {
                y = 90;
        } <font color="blue">else</font> {
                fatal_error("<font color="blue">draw_timer_tick</font>");
                y = -1;
        }

        uszprintf(buf, <font color="blue">sizeof</font>(buf), "<font color="blue">Timer:&nbsp;%ld</font>", count);
        print(400, y, buf);
}



<font color="blue">void</font> draw_mouse_button(<font color="blue">int</font> but, bool down)
{
        <font color="blue">const</font> <font color="blue">int</font> offset[3] = {0, 70, 35};
        <font color="blue">int</font> x;
        <font color="blue">int</font> y;

        x = 400 + offset[but-1];
        y = 130;

        al_draw_rectangle(x, y, x + 26.5, y + 41.5, grey, ALLEGRO_FILLED);
        al_draw_rectangle(x, y, x + 26.5, y + 41.5, black, ALLEGRO_OUTLINED);
        <font color="blue">if</font> (down) {
                al_draw_rectangle(x + 2, y + 2, x + 24.5, y + 39.5, black, ALLEGRO_FILLED);
        }
}



<font color="blue">void</font> draw_mouse_pos(<font color="blue">int</font> x, <font color="blue">int</font> y, <font color="blue">int</font> z, <font color="blue">int</font> w)
{
        <font color="blue">char</font> buf[MAX_MSG_LEN];

        uszprintf(buf, <font color="blue">sizeof</font>(buf), "<font color="blue">(%d,&nbsp;%d,&nbsp;%d,&nbsp;%d) </font>", x, y, z, w);
        print(400, 180, buf);
}



<font color="blue">void</font> draw_joystick_axes(ALLEGRO_JOYSTICK_STATE *jst)
{
        <font color="blue">float</font> joys_x;
        <font color="blue">float</font> joys_y;
        <font color="blue">int</font> x;
        <font color="blue">int</font> y;

        joys_x = jst-&gt;stick[0].axis[0];
        joys_y = jst-&gt;stick[0].axis[1];
        x = 470 + joys_x * 50;
        y = 300 + joys_y * 50;

        al_draw_rectangle(470-60, 300-60, 470+60.5, 300+60.5, grey, ALLEGRO_FILLED);
        al_draw_rectangle(470-60, 300-60, 470+60.5, 300+60.5, black,
        ALLEGRO_OUTLINED);
        al_draw_rectangle(x-5, y-5, x+5.5, y+5.5, black, ALLEGRO_FILLED);
}



<font color="blue">void</font> draw_joystick_button(<font color="blue">int</font> button, bool down)
{
        <font color="blue">int</font> x;
        <font color="blue">int</font> y;

        x = 400 + (button&nbsp;% 5) * 30;
        y = 400 + (button / 5) * 30;

        al_draw_rectangle(x, y, x + 25.5, y + 25.5, grey, ALLEGRO_FILLED);
        al_draw_rectangle(x, y, x + 25.5, y + 25.5, black, ALLEGRO_OUTLINED);
        <font color="blue">if</font> (down) {
                al_draw_rectangle(x + 2, y + 2, x + 24.5, y + 24.5, black,
                ALLEGRO_FILLED);
        }
}



<font color="blue">void</font> draw_joystick_buttons(<font color="blue">int</font> num_buttons, ALLEGRO_JOYSTICK_STATE *jst)
{
        <font color="blue">int</font> i;

        <font color="blue">for</font> (i = 0; i &lt; num_buttons; i++) {
                draw_joystick_button(i, jst-&gt;button[i] &gt;= 16384);
        }
}



<font color="blue">void</font> draw_all(<font color="blue">void</font>)
{
        ALLEGRO_MOUSE_STATE mst;
        ALLEGRO_JOYSTICK *joy;
        ALLEGRO_JOYSTICK_STATE jst;
        <font color="blue">int</font> num_buttons;

        <font color="green" style="font-style=italic;">/* Clear the screen. */</font>
        al_clear(white);

        al_get_mouse_state(&amp;mst);
        draw_mouse_pos(mst.x, mst.y, mst.z, mst.w);
        draw_mouse_button(1, al_mouse_button_down(&amp;mst, 1));
        draw_mouse_button(2, al_mouse_button_down(&amp;mst, 2));
        draw_mouse_button(3, al_mouse_button_down(&amp;mst, 3));

        draw_timer_tick(timer_a, al_get_timer_count(timer_a));
        draw_timer_tick(timer_b, al_get_timer_count(timer_b));
        draw_timer_tick(timer_c, al_get_timer_count(timer_c));

        <font color="blue">if</font> (al_num_joysticks() &gt; 0) {
                joy = al_get_joystick(0);
                num_buttons = al_get_num_joystick_buttons(joy);
                al_get_joystick_state(joy, &amp;jst);
                draw_joystick_axes(&amp;jst);
                draw_joystick_buttons(num_buttons, &amp;jst);
        }

        draw_message_log();

        al_flip_display();
}



<font color="green" style="font-style=italic;">/* main_loop:
*  The main loop of the program.  Here we wait for events to come in from
*  any one of the event sources and react to each one accordingly.  While
*  there are no events to react to the program sleeps and consumes very
*  little CPU time.  See main() to see how the event sources and event queue
*  are set up.
*/</font>
<font color="blue">void</font> main_loop(<font color="blue">void</font>)
{
        ALLEGRO_EVENT event;

        <font color="blue">while</font> (true) {
                draw_all();

                <font color="green" style="font-style=italic;">/* Take the next event out of the event queue, and store it in `event'. */</font>
                al_wait_for_event(event_queue, &amp;event);

                <font color="green" style="font-style=italic;">/* Check what type of event we got and act accordingly.  ALLEGRO_EVENT
                * is a union type and interpretation of its contents is dependent on
                * the event type, which is given by the 'type' field.
                *
                * Each event also comes from an event source and has a timestamp.
                * These are accessible through the 'any.source' and 'any.timestamp'
                * fields respectively, e.g. 'event.any.timestamp'
                */</font>
                <font color="blue">switch</font> (event.type) {

                        <font color="green" style="font-style=italic;">/* ALLEGRO_EVENT_KEY_DOWN - a keyboard key was pressed.
                        * The three keyboard event fields we use here are:
                        *
                        * keycode -- an integer constant representing the key, e.g.
                        *             AL_KEY_ESCAPE;
                        *
                        * unichar -- the Unicode character being typed, if any.  This can
                        *             depend on the modifier keys and previous keys that were
                        *             pressed, e.g. for accents.
                        *
                        * modifiers -- a bitmask containing the state of Shift/Ctrl/Alt, etc.
                        *             keys.
                        */</font>
                        <font color="blue">case</font> ALLEGRO_EVENT_KEY_DOWN:
                        <font color="blue">if</font> (event.keyboard.keycode == ALLEGRO_KEY_ESCAPE) {
                                <font color="blue">return</font>;
                        }
                        log_key_down(event.keyboard.keycode,
                        event.keyboard.unichar,
                        event.keyboard.modifiers);
                        <font color="blue">break</font>;

                        <font color="green" style="font-style=italic;">/* ALLEGRO_EVENT_KEY_REPEAT - a keyboard key was held down long enough to
                        * 'repeat'.  This is a useful event if you are working on something
                        * that requires typed input.  The repeat rate should be determined
                        * by the operating environment the program is running in.
                        */</font>
                        <font color="blue">case</font> ALLEGRO_EVENT_KEY_REPEAT:
                        log_key_repeat(event.keyboard.keycode,
                        event.keyboard.unichar,
                        event.keyboard.modifiers);
                        <font color="blue">break</font>;

                        <font color="green" style="font-style=italic;">/* ALLEGRO_EVENT_KEY_UP - a keyboard key was released.
                        * Note that the unichar field is unused for this event.
                        */</font>
                        <font color="blue">case</font> ALLEGRO_EVENT_KEY_UP:
                        log_key_up(event.keyboard.keycode,
                        event.keyboard.unichar,
                        event.keyboard.modifiers);
                        <font color="blue">break</font>;

                        <font color="green" style="font-style=italic;">/* ALLEGRO_EVENT_MOUSE_AXES - at least one mouse axis changed value.
                        * The 'z' axis is for the scroll wheel.  We also have a fourth 'w'
                        * axis for mice with two scroll wheels.
                        */</font>
                        <font color="blue">case</font> ALLEGRO_EVENT_MOUSE_AXES:
                        draw_mouse_pos(event.mouse.x, event.mouse.y, event.mouse.z,
                        event.mouse.w);
                        <font color="blue">break</font>;

                        <font color="green" style="font-style=italic;">/* ALLEGRO_EVENT_MOUSE_BUTTON_UP - a mouse button was pressed.
                        * The axis fields are also valid for this event.
                        */</font>
                        <font color="blue">case</font> ALLEGRO_EVENT_MOUSE_BUTTON_DOWN:
                        draw_mouse_button(event.mouse.button, true);
                        <font color="blue">break</font>;

                        <font color="green" style="font-style=italic;">/* ALLEGRO_EVENT_MOUSE_BUTTON_UP - a mouse button was released.
                        * The axis fields are also valid for this event.
                        */</font>
                        <font color="blue">case</font> ALLEGRO_EVENT_MOUSE_BUTTON_UP:
                        draw_mouse_button(event.mouse.button, false);
                        <font color="blue">break</font>;

                        <font color="green" style="font-style=italic;">/* ALLEGRO_EVENT_TIMER - a timer 'ticked'.
                        * The `source' field in the event structure tells us which timer
                        * went off, and the `count' field tells us the timer's counter
                        * value at the time that the event was generated.  It's not
                        * redundant, because although you can query the timer for its
                        * counter value, that value might have changed by the time you got
                        * around to processing this event.
                        */</font>
                        <font color="blue">case</font> ALLEGRO_EVENT_TIMER:
                        draw_timer_tick(event.timer.source, event.timer.count);
                        <font color="blue">break</font>;

                        <font color="green" style="font-style=italic;">/* ALLEGRO_EVENT_JOYSTICK_AXIS - a joystick axis value changed.
                        * For simplicity, in this example we only work with the first
                        * 'stick' on the first joystick on the system.
                        */</font>
                        <font color="blue">case</font> ALLEGRO_EVENT_JOYSTICK_AXIS:
                        <font color="blue">break</font>;

                        <font color="green" style="font-style=italic;">/* ALLEGRO_EVENT_JOYSTICK_BUTTON_DOWN - a joystick button was pressed.
                        */</font>
                        <font color="blue">case</font> ALLEGRO_EVENT_JOYSTICK_BUTTON_DOWN:
                        <font color="blue">break</font>;

                        <font color="green" style="font-style=italic;">/* ALLEGRO_EVENT_JOYSTICK_BUTTON_UP - a joystick button was released.
                        */</font>
                        <font color="blue">case</font> ALLEGRO_EVENT_JOYSTICK_BUTTON_UP:
                        <font color="blue">break</font>;

                        <font color="green" style="font-style=italic;">/* ALLEGRO_EVENT_DISPLAY_CLOSE - the window close button was pressed.
                        */</font>
                        <font color="blue">case</font> ALLEGRO_EVENT_DISPLAY_CLOSE:
                        <font color="blue">return</font>;

                        <font color="blue">case</font> ALLEGRO_EVENT_DISPLAY_SWITCH_IN:
                        log_general("<font color="blue">Switch In</font>");
                        <font color="blue">break</font>;

                        <font color="blue">case</font> ALLEGRO_EVENT_DISPLAY_SWITCH_OUT:
                        log_general("<font color="blue">Switch Out</font>");
                        <font color="blue">break</font>;

                        <font color="green" style="font-style=italic;">/* We received an event of some type we don't know about.
                        * Just ignore it.
                        */</font>
                        <font color="blue">default</font>:
                        <font color="blue">break</font>;
                }
        }
}



<font color="blue">int</font> main(<font color="blue">void</font>)
{
        <font color="blue">int</font> num;
        <font color="blue">int</font> i;

        <font color="green" style="font-style=italic;">/* Initialise Allegro. */</font>
        al_init();

        <font color="green" style="font-style=italic;">/* Install the mouse handler. */</font>
        <font color="blue">if</font> (!al_install_mouse()) {
                fatal_error("<font color="blue">al_install_mouse</font>");
        }

        al_font_init();

        <font color="green" style="font-style=italic;">/* Open a window. This function is part of the new display API and is
        * still in flux.
        */</font>
        display = al_create_display(WIDTH, HEIGHT);
        <font color="blue">if</font> (!display) {
                fatal_error("<font color="blue">al_create_display</font>");
        }

        <font color="green" style="font-style=italic;">/* Install the keyboard handler.  In the new API, the install functions
        * return 'false' on error instead of 0.
        */</font>
        <font color="blue">if</font> (!al_install_keyboard()) {
                fatal_error("<font color="blue">al_install_keyboard</font>");
        }

        <font color="green" style="font-style=italic;">/* Show the mouse cursor.  Currently this relies on the video card or
        * operating environment being able to overlay a mouse cursor on top of
        * the screen (or Allegro window).  If that is not possible then the user
        * would be responsible for drawing the mouse cursor himself.
        */</font>
        al_show_mouse_cursor();

        myfont = al_font_load_font("<font color="blue">data/fixed_font.tga</font>", 0);
        <font color="blue">if</font> (!myfont) {
                TRACE("<font color="blue">fixed_font.tga not found\n</font>");
                <font color="blue">return</font> 1;
        }
        black = al_map_rgb(0, 0, 0);
        grey = al_map_rgb(0xe0, 0xe0, 0xe0);
        white = al_map_rgb(255, 255, 255);

        <font color="green" style="font-style=italic;">/* Install the joystick routines. */</font>
        al_install_joystick();

        <font color="green" style="font-style=italic;">/* Create three timer objects.  Unlike in the earlier API, these
        * automatically increment a counter every n milliseconds.  They no longer
        * run user-defined callbacks.
        */</font>
        timer_a = al_install_timer(0.100);
        timer_b = al_install_timer(1.000);
        timer_c = al_install_timer(5.000);
        <font color="blue">if</font> (!timer_a ||&nbsp;!timer_b ||&nbsp;!timer_c) {
                fatal_error("<font color="blue">al_install_timer</font>");
        }

        <font color="green" style="font-style=italic;">/* Create an event queue. These collect events which are generated by
        * event sources.  In this example we demonstrate four types of event
        * sources: the keyboard, the mouse, joysticks and timers.
        */</font>
        event_queue = al_create_event_queue();
        <font color="blue">if</font> (!event_queue) {
                fatal_error("<font color="blue">al_create_event_queue</font>");
        }

        <font color="green" style="font-style=italic;">/* To tell event sources where to deliver any events that they generate, we
        * 'register' event sources with event queues.  An event source can register
        * itself with multiple event queues at the same time.  An event generated
        * by such an event source would be delivered to each of those event queues.
        * Most of the time, you wouldn't need that feature.
        *
        * al_get_keyboard() and al_get_mouse() return objects which represent the
        * keyboard and mouse respectively.  For simplicity, the API assumes there
        * is only one of each on the system.  The timer objects were created
        * earlier with al_install_timer().
        *
        * The type-casts to ALLEGRO_EVENT_SOURCE* are unfortunately required.
        */</font>
        al_register_event_source(event_queue, (ALLEGRO_EVENT_SOURCE *)al_get_keyboard());
        al_register_event_source(event_queue, (ALLEGRO_EVENT_SOURCE *)al_get_mouse());
        al_register_event_source(event_queue, (ALLEGRO_EVENT_SOURCE *)timer_a);
        al_register_event_source(event_queue, (ALLEGRO_EVENT_SOURCE *)timer_b);
        al_register_event_source(event_queue, (ALLEGRO_EVENT_SOURCE *)timer_c);
        al_register_event_source(event_queue, (ALLEGRO_EVENT_SOURCE *)display);

        <font color="green" style="font-style=italic;">/* Register all the joysticks on the system with the event queue as well. */</font>
        num = al_num_joysticks();
        <font color="blue">for</font> (i = 0; i &lt; num; i++) {
                ALLEGRO_EVENT_SOURCE *joysrc = (ALLEGRO_EVENT_SOURCE *)al_get_joystick(i);
                al_register_event_source(event_queue, joysrc);
        }

        <font color="green" style="font-style=italic;">/* Timers are not automatically started when they are created.  Start them
        * now before we enter the main loop.
        */</font>
        al_start_timer(timer_a);
        al_start_timer(timer_b);
        al_start_timer(timer_c);

        <font color="green" style="font-style=italic;">/* Run the main loop. */</font>
        main_loop();

        <font color="green" style="font-style=italic;">/* For now, Allegro still automatically registers allegro_exit() with
        * atexit() when you install it.  Further, all subsystems (keyboard, etc.)
        * are automatically shut down when Allegro is shut down.  All event queues
        * are also automatically destroyed.  So we don't actually need any
        * explicit shutdown code here.
        */</font>

        <font color="blue">return</font> 0;
}
END_OF_MAIN()

<font color="green" style="font-style=italic;">/* vi: set ts=8 sts=3 sw=3 et: */</font>
</pre></div>

<!-- Saved in parser cache with key awiki:pcache:idhash:590-0!1!0!!en!2!edit=0 and timestamp 20080918014848 -->
<div class="printfooter">
Retrieved from "<a href="http://wiki.allegro.cc/index.php?title=NewAPI/exnew_events.c">http://wiki.allegro.cc/index.php?title=NewAPI/exnew_events.c</a>"</div>
						<!-- end content -->
			<div class="visualClear"></div>
		</div>
	</div>
		</div>
		<div id="column-one">
	<div id="p-cactions" class="portlet">
		<h5>Views</h5>
		<div class="pBody">
			<ul>
					 <li id="ca-nstab-main" class="selected"><a href="/index.php?title=NewAPI/exnew_events.c" title="View the content page [c]" accesskey="c">Article</a></li>
					 <li id="ca-talk" class="new"><a href="/index.php?title=Talk:NewAPI/exnew_events.c&amp;action=edit" title="Discussion about the content page [t]" accesskey="t">Talk</a></li>
					 <li id="ca-viewsource"><a href="/index.php?title=NewAPI/exnew_events.c&amp;action=edit" title="This page is protected. You can view its source. [e]" accesskey="e">View source</a></li>
					 <li id="ca-history"><a href="/index.php?title=NewAPI/exnew_events.c&amp;action=history" title="Past versions of this page. [h]" accesskey="h">History</a></li>
				</ul>
		</div>
	</div>
	<div class="portlet" id="p-personal">
		<h5>Personal tools</h5>
		<div class="pBody">
			<ul>
				<li id="pt-login"><a href="/index.php?title=Special:Userlogin&amp;returnto=NewAPI/exnew_events.c" title="You are encouraged to log in, it is not mandatory however. [o]" accesskey="o">Log in / create account</a></li>
			</ul>
		</div>
	</div>
	<div class="portlet" id="p-logo">
		<a style="background-image: url(/pub/e/e2/Alex-logo.png);" href="/index.php?title=Main_Page" title="Visit the Main Page [z]" accesskey="z"></a>
	</div>
	<script type="text/javascript"> if (window.isMSIE55) fixalpha(); </script>
		<div class='portlet' id='p-navigation'>
		<h5>Navigation</h5>
		<div class='pBody'>
			<ul>
				<li id="n-mainpage"><a href="/index.php?title=Main_Page" title="Visit the Main Page [z]" accesskey="z">Main Page</a></li>
				<li id="n-Articles"><a href="/index.php?title=Category:Articles">Articles</a></li>
				<li id="n-News"><a href="/index.php?title=Allegro_Wiki:News">News</a></li>
				<li id="n-recentchanges"><a href="/index.php?title=Special:Recentchanges" title="The list of recent changes in the wiki. [r]" accesskey="r">Recent changes</a></li>
				<li id="n-randompage"><a href="/index.php?title=Special:Random" title="Load a random page [x]" accesskey="x">Random page</a></li>
				<li id="n-help"><a href="http://en.wikipedia.org/wiki/Help:Contents" title="The place to find out.">Help</a></li>
				<li id="n-sitesupport"><a href="/index.php?title=Allegro_Wiki:Site_support" title="Support us">Donations</a></li>
				<li id="n-allegrocc"><a href="http://www.allegro.cc">Allegro.cc</a></li>
			</ul>
		</div>
	</div>
		<div id="p-search" class="portlet">
		<h5><label for="searchInput">Search</label></h5>
		<div id="searchBody" class="pBody">
			<form action="/index.php?title=Special:Search" id="searchform"><div>
				<input id="searchInput" name="search" type="text" title="Search Allegro Wiki [f]" accesskey="f" value="" />
				<input type='submit' name="go" class="searchButton" id="searchGoButton"	value="Go" />&nbsp;
				<input type='submit' name="fulltext" class="searchButton" id="mw-searchButton" value="Search" />
			</div></form>
		</div>
	</div>
	<div class="portlet" id="p-tb">
		<h5>Toolbox</h5>
		<div class="pBody">
			<ul>
				<li id="t-whatlinkshere"><a href="/index.php?title=Special:Whatlinkshere/NewAPI/exnew_events.c" title="List of all wiki pages that link here [j]" accesskey="j">What links here</a></li>
				<li id="t-recentchangeslinked"><a href="/index.php?title=Special:Recentchangeslinked/NewAPI/exnew_events.c" title="Recent changes in pages linked from this page [k]" accesskey="k">Related changes</a></li>
<li id="t-upload"><a href="/index.php?title=Special:Upload" title="Upload images or media files [u]" accesskey="u">Upload file</a></li>
<li id="t-specialpages"><a href="/index.php?title=Special:Specialpages" title="List of all special pages [q]" accesskey="q">Special pages</a></li>
				<li id="t-print"><a href="/index.php?title=NewAPI/exnew_events.c&amp;printable=yes" title="Printable version of this page [p]" accesskey="p">Printable version</a></li>				<li id="t-permalink"><a href="/index.php?title=NewAPI/exnew_events.c&amp;oldid=4602" title="Permanent link to this version of the page">Permanent link</a></li>			</ul>
		</div>
	</div>
		</div><!-- end of the left (by default at least) column -->
			<div class="visualClear"></div>
			<div id="footer">
				<div id="f-poweredbyico"><a href="http://www.mediawiki.org/"><img src="/skins/common/images/poweredby_mediawiki_88x31.png" alt="Powered by MediaWiki" /></a></div>
			<ul id="f-list">
				<li id="lastmod"> This page was last modified 13:12, September 4, 2008.</li>
				<li id="viewcount">This page has been accessed 486 times.</li>
				<li id="privacy"><a href="/index.php?title=Allegro_Wiki:Privacy_policy" title="Allegro Wiki:Privacy policy">Privacy policy</a></li>
				<li id="about"><a href="/index.php?title=Allegro_Wiki:About" title="Allegro Wiki:About">About Allegro Wiki</a></li>
				<li id="disclaimer"><a href="/index.php?title=Allegro_Wiki:General_disclaimer" title="Allegro Wiki:General disclaimer">Disclaimers</a></li>
			</ul>
		</div>
		
	
		<script type="text/javascript">if (window.runOnloadHook) runOnloadHook();</script>
</div>
<!-- Served in 0.720 secs. --></body></html>
